/* Copyright 2012 Tobias Marschall
 * 
 * This file is part of CLEVER.
 * 
 * CLEVER is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CLEVER is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CLEVER.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef INSERTLENGTHDISTRIBUTION_H_
#define INSERTLENGTHDISTRIBUTION_H_

#include <vector>

class InsertLengthDistribution {
private:
	int min;
	int max;
	// pairs of start position and probability
	typedef std::pair<int,double> value_t;
	std::vector<value_t> values;
public:
	/** Reads a distribution from a file whose lines have the following format: <start> <end> <probability>
	 * 	where the last column must add up to one.*/
	InsertLengthDistribution(const std::string& filename);
	virtual ~InsertLengthDistribution();
	double probability(int insert_length) const;

	friend std::ostream& operator<<(std::ostream&, const InsertLengthDistribution& ild);
};

#endif /* INSERTLENGTHDISTRIBUTION_H_ */
